SCRIPT MCO_IT
/****************************************************************************
  Description: Script to read and write MCO data to a text file (.PRT)
					to enable to print on plain paper (3 copies)

  Author: Paul Shrimpton                 Date: 27 May 2008
  Revisions:
****************************************************************************/

VARIABLES
RET_CODE = 0                            // generic return code variable
agency_name = ""
agency_sid_sine = ""
airline_name = ""
all_pax_check_box = 0
carrier = ""
carrier_location = ""
col = 0
//col_std = 0
//col_sti = 0
comm_amount = ""
comm_percentage = ""
comm_percentage_pos = 0
conjunction = ""
count = 0
cur = ""
currency = ""
date='00/00/00'
date_of_issue = ""
day=0
dom_or_Int = ""
doc_history_item = ""
endorsement = ""
endorse_1 = ""
endorse_2 = ""
fare = ""
fare_amount = ""
fare_per_pax = ""
fare_pos = 0
fare_with_tax = ""
fare_without_tax = ""
fare_with_tax_num = 0
fare_without_tax_num = 0
file_id = 0
file_id2 = 0
filename = ""
fop = ""
header = ""
iata = ""
iata_part1 = ""
iata_part2 = ""
in_exchange_for = ""
interface_record = ""
locator = ""
mco_airline_name_length = 0
mco_record = 0
mco_number = ""
month = 0
name_count = 0
name_details = ""
name_id = ""
name_id_list = ""
name_list = ""
name_select_switch = 0
orig_fop = ""
orig_date_of_issue = ""
orig_IATA = ""
orig_place_of_issue = ""
orig_tkt_number = ""
pax_name = ""
pax_9_name = ""
pax_9 = 0
pax_8_name = ""
pax_8 = 0
pax_7_name = ""
pax_7 = 0
pax_6_name = ""
pax_6 = 0
pax_5_name = ""
pax_5 = 0
pax_4_name = ""
pax_4 = 0
pax_3_name = ""
pax_3 = 0
pax_2_name = ""
pax_2 = 0
pax_1_name = ""
pax_1 = 0
pi_and_cf_codes = ""
pos = 0
pos1 = 0
pos2 = 0
position = 0
position_end_of_fare = 0
position_total_fare = 0
reason_for_issuance = ""
refund_voucher = 0
remark = ""
remark_1 = ""
remark_2 = ""
remark_3 = ""
remark_4 = ""
remark_test = ""
row = 0
//row_std = 0
//row_sti = 0
$r_intNameCount = 0
specified_pax_switch = 0
$StrButton = ""
tax_amount = ""
temp_count = 0
tktdate = ""
total_tax_amount_num = 0
total_tax_amount = ""
tour_code = ""
type_of_service = ""
//vat = ""
//vat_test = ""
year=0
year2 = ""
yeart=""
years = '00/00/00'





ROUTINES
	//*********************************************
	//********** WRITE TO FILE AND PRINT **********	
	//*********************************************
	write_to_text_file 
	BEGIN
		filename = "C:\" + locator + ".PRT"
		OPEN(filename,WRITE_MODE,file_id,RET_CODE)

		IF RET_CODE <> 1 THEN
			ABORT("Script Aborting  - Unable to write MCO data to " + filename)
		ENDIF

		WRITE(file_id,header,RET_CODE)
		WRITE(file_id,"     ",RET_CODE)
		WRITE(file_id,"Agency Name - "+ agency_name,RET_CODE)
		WRITE(file_id,"IATA - "+ iata,RET_CODE)
		WRITE(file_id,"Date of Issue - " + date_of_issue,RET_CODE)
		WRITE(file_id,"     ",RET_CODE)
		WRITE(file_id,"PNR Locator - "+ locator + "/1P",RET_CODE)
		WRITE(file_id,"Agency SID/SINE - " + agency_sid_sine,RET_CODE)
		WRITE(file_id,"RFIC (Reason for Issuance) - " + reason_for_issuance,RET_CODE)
		WRITE(file_id,"Type of Service - " + type_of_service,RET_CODE)
		WRITE(file_id,"Airline Name - " + airline_name,RET_CODE)
		WRITE(file_id,"AT (Carrier Location) - " + carrier_location,RET_CODE)
		WRITE(file_id,"Airline PI and CF codes - " + pi_and_cf_codes,RET_CODE)
		WRITE(file_id,"Endorsements - " + endorsement,RET_CODE)
		WRITE(file_id,"Tour Code - " + tour_code,RET_CODE)

		IF count = 1 THEN
			//If only one pax in PNR.  Data pulled from *DH
			WRITE(file_id,"Pax Name - " + pax_name,RET_CODE)
		ELSE
			WRITE(file_id,name_list,RET_CODE)
		ENDIF


		IF dom_or_Int = "D" THEN
			WRITE(file_id,"VAT - INCLUDED",RET_CODE)
		ELSE
			WRITE(file_id,"VAT - NOT INCLUDED",RET_CODE)
		ENDIF

		WRITE(file_id,"Fare Calculation - " + remark,RET_CODE)
		WRITE(file_id,"Fare Amount (breakdown) - " + fare_amount,RET_CODE)
		WRITE(file_id,"Tax Amount - " + tax_amount,RET_CODE)
		WRITE(file_id,"Commission Amount - " + comm_amount,RET_CODE)
		WRITE(file_id,"In Exchange For - " + in_exchange_for,RET_CODE)
		WRITE(file_id,"In Conjunction With - " + conjunction,RET_CODE)
		WRITE(file_id,"Form of Payment - " + fop,RET_CODE)
		WRITE(file_id,"MCO Number - " + mco_number,RET_CODE)
		WRITE(file_id,"Fare Amount - " + currency + " " + fare,RET_CODE)
		WRITE(file_id,"Commission Percentage - " + comm_percentage,RET_CODE)
		WRITE(file_id,"Total Tax Amount - " + total_tax_amount,RET_CODE)

		CLOSE(file_id,RET_CODE)
		PRINT(filename,RET_CODE)

		IF RET_CODE = 0 THEN
			DEL(filename,RET_CODE)
			ABORT("Script Aborting  - Printer Error. Unable to print MCO data.")
		ENDIF

		DEL(filename,RET_CODE)
	END
	RETURN	




	//*********************************************
	//************** READ MCO DATA ****************	
	//*********************************************
	retrieve_mco_template_data
	BEGIN
		READ_SCREEN(2,5,50,airline_name)

		//Remove spaces from airline name
		INSTR(airline_name,"   ",1,pos)
		SUBSTR(airline_name,airline_name,1,pos-1)
		
		READ_SCREEN(3,5,28,carrier_location)
		READ_SCREEN(3,54,1,reason_for_issuance)
		READ_SCREEN(4,14,50,type_of_service)
		READ_SCREEN(6,6,3,currency)
		READ_SCREEN(6,16,9,fare)

		//*** Is this FARE PER PAX ? ***
		READ_SCREEN(6,48,1,fare_per_pax)		


		//*** Is this an Agent Refund Voucher ? ***
		SCREEN_SEARCH(1,1,"MCO  2  1-ORIGINAL ISSUE 2-AGENT REFUND VOUCHER",row,col)

		IF row <> 0 AND reason_for_issuance = "K" THEN
			refund_voucher = 1
		ENDIF
		
		//*** Remove spaces in front of fare ***
		IF fare <> "         " THEN
			col = 1
			REPEAT
				INSTR(fare," ",col,fare_pos)
				IF fare_pos <> 0 THEN
					col = col + 1
				ENDIF
			UNTIL fare_pos = 0

			SUBSTR(fare,fare,col,10-col)
		ENDIF


		//*** Commission Percentage ***
		READ_SCREEN(5,52,8,comm_percentage)
		
		IF comm_percentage <> "        " THEN
			//*** Remove spaces in front of comm ***
			col = 1
			REPEAT
				INSTR(comm_percentage," ",col,comm_percentage_pos)
				IF comm_percentage_pos <> 0 THEN
					col = col + 1
				ENDIF
			UNTIL comm_percentage_pos = 0

			SUBSTR(comm_percentage,comm_percentage,col,9-col)
		ENDIF

		//*** Retrieve endorsement and fare calc from seconf page of template ***
		SCREEN_SEARCH(1,1,"DATA (Y)",row,col)

		IF row <> 0 THEN
			BACKTAB(2)
			SEND("X")
			TAB
			SEND("F")XMIT
		ELSE
			BACKTAB
			SEND("F")XMIT			
		ENDIF

		//*** Endorsements ***
		READ_SCREEN(5,14,52,endorse_1)	
		READ_SCREEN(6,1,7,endorse_2)	

		endorsement = endorse_1 + endorse_2

		//*** Remarks (FARE CALCULATION)- Made up of multiple lines***
		READ_SCREEN(8,9,56,remark_1)
		READ_SCREEN(9,1,64,remark_2)
		READ_SCREEN(10,1,64,remark_3)	
		READ_SCREEN(11,1,34,remark_4)	

		remark = remark_1

		//Are any of the lines empty ?
		SUBSTR(remark_test,remark_2,1,4)

		IF remark_test <> "    " THEN
			remark = remark + remark_2
		ENDIF

		remark_test = ""
		SUBSTR(remark_test,remark_3,1,4)

		IF remark_test <> "    " THEN
			remark = remark + remark_3
		ENDIF

		remark_test = ""
		SUBSTR(remark_test,remark_4,1,4)

		IF remark_test <> "    " THEN
			remark = remark + remark_4
		ENDIF

	END
	RETURN		




	//*********************************************
	//*********** READ DOCUMENT HISTORY ***********	
	//*********************************************
	document_history
   BEGIN	
		//*** Date of Issue ***
		TODAY(years)
		GETDATE (years,day,month,year)
		FORMAT(year,yeart,"0000")
		SUBSTR(year2,yeart,3,2)
		READ_SCREEN(2,4,5,tktdate)
		STRING2DATE(tktdate,date,RET_CODE)
		date_of_issue = tktdate + year2

		//*** Agency SID/SINE ***	
		READ_SCREEN(2,15,9,agency_sid_sine)


		//*** Airline PI and CF codes ***
		:pi_and_cf
		SCREEN_SEARCH(1,1,"MENDOR",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO pi_and_cf
			ENDIF
		ELSE
			READ_SCREEN(row,11,60,pi_and_cf_codes)
		ENDIF


		//*** Tour Codes ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF
		:tour_codes
		SCREEN_SEARCH(1,1,"MTOUR",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO tour_codes
			ENDIF
		ELSE
			READ_SCREEN(row,11,12,tour_code)
		ENDIF
		
		
		//*** Pax Name ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF

		READ_SCREEN(3,4,56,pax_name)


		//*** VAT included or not included ***
		/*
		SCREEN_SEARCH(1,1,"EZ",row,col)
		SCREEN_SEARCH(row,1,"STD ",row_std,col_std)
		SCREEN_SEARCH(row,1,"STI ",row_sti,col_sti)	

		IF row_std = row THEN
			vat = "D"
		ENDIF

		IF row_sti = row THEN
			vat = "I"	
		ENDIF

		IF vat = "" THEN
			READ_SCREEN (row+1,4,5,vat_test)

			IF vat_test <> "AGENT" THEN
				//*** More EZ data to read ***
				SCREEN_SEARCH(row+1,1,"STD ",row_std,col_std)
				SCREEN_SEARCH(row+1,1,"STI ",row_sti,col_sti)	

				IF row_std = row+1 THEN
					vat = "D"	
				ENDIF

				IF row_sti = row+1 THEN
					vat = "I"	
				ENDIF
			ENDIF
		ENDIF

		IF vat = "" THEN
			ABORT("Script Aborting - Unable to proceed without an 'STD' or 'STI' indicator in the document history - EZ line")
		ENDIF	
		*/


		//*** In Exchange For ***
		:exchange
		SCREEN_SEARCH(1,1," MIS   ",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO exchange
			ENDIF
		ELSE
			READ_SCREEN(row,11,13,in_exchange_for)
		ENDIF


		//*** In Conjunction With ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF

		SCREEN_SEARCH(1,1,"EZ",row,col)
		SCREEN_SEARCH(row,1,"#$*EET",row,col)
		
		IF row <> 0 THEN
			READ_SCREEN(row,col + 6,14,conjunction) 
		ENDIF

		//*** Form of Payment ***
		:fop
		SCREEN_SEARCH(1,1,"MFOP",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO fop
			ENDIF
		ELSE
			READ_SCREEN(row,11,60,fop)
		ENDIF

		//*** MCO Number ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF

		SCREEN_SEARCH(1,1,"*M",row,col)

		IF row = 2 THEN
			READ_SCREEN(row,col + 2,13,mco_number) 
		ENDIF


		//*** Fare Amount & Total Tax Amount ***
		:fare_amt
		SCREEN_SEARCH(1,1,"MAMT",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO fare_amt
			ENDIF
		ELSE
			READ_SCREEN(row,11,60,fare_amount)

			//*** Calculate Total Tax Amount ***
			INSTR(fare_amount,"/",1,position)
			SUBSTR(fare_without_tax,fare_amount,4,position-4)
			SUBSTR(cur,fare_amount,1,3)
			cur = "/" + cur  //*** e.g.'/EUR'
			INSTR(fare_amount,cur,1,position_total_fare)

			IF position_total_fare = 0 or position_total_fare = position THEN
				//*** No tax detected ***
				total_tax_amount = ""
				GOTO continue
			ENDIF

			INSTR(fare_amount,"  ",1,position_end_of_fare) //*** Where is end of fare data ?
			//*** Retrieve total fare and tax amount ***
			SUBSTR(fare_with_tax,fare_amount,position_total_fare+4,(position_end_of_fare - position_total_fare)+4)

			MAKENUM(fare_with_tax,fare_with_tax_num)
			MAKENUM(fare_without_tax,fare_without_tax_num)
			total_tax_amount_num = fare_with_tax_num - fare_without_tax_num
			FORMAT(total_tax_amount_num, total_tax_amount,".00") 

	
		ENDIF

		:continue

		//*** Tax Amount ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF
		:tax_amt
		SCREEN_SEARCH(1,1,"MTKTAX",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO tax_amt
			ENDIF
		ELSE
			READ_SCREEN(row,11,60,tax_amount)
		ENDIF


		//*** Commission Amount ***
		SCREEN_SEARCH(1,1," **DOCUMENT COMMANDS** ",row,col)
		IF row = 0 THEN
			SEND("MT")XMIT
		ENDIF
		:comm_amt
		SCREEN_SEARCH(1,1,"MCOMM",row,col)
		
		IF row = 0 THEN
			SCREEN_SEARCH(1,1,")>",row,col)
			IF row <> 0 THEN
				SEND("MD")XMIT
				GOTO comm_amt
			ENDIF
		ELSE
			READ_SCREEN(row,14,60,comm_amount)
		ENDIF

	END
	RETURN



	//****************************************************************************************************
	//**************************************** MAIN SCRIPT ***********************************************
	//****************************************************************************************************	
	BEGIN
		ERASE_ALL
		JUMP_CURSOR (1)
		//*** Retrieve Issuing Agency Name & IATA
		SEND("4G")XMIT
		SCREEN_SEARCH(2,1,"   ",row,col)
		READ_SCREEN(2,1,col-1,agency_name)
		READ_SCREEN(4,9,2,iata_part1)
		READ_SCREEN(4,12,5,iata_part2)
		iata = iata_part1 + iata_part2

		//*** Active PNR present ? ***
		:start
		SEND("*A")XMIT
		SCREEN_SEARCH(1,1,"INVALID A",row,col)

		IF row <> 0 THEN
			DIALOG ("MCO_IT3.DLG", RET_CODE, locator)
			SEND("*" + locator)XMIT
			GOTO start
		ENDIF

		IF locator = "" THEN
			SCREEN_SEARCH(1,1,"1P- `06X",row,col)
			READ_SCREEN(row,col + 4,6,locator)
		ENDIF


		//*** Obtain number of pax - Name data is stored in C:\nametlist.txt ***
		CALL("MCO_NAM.CSC")
		count = $r_intNameCount  //count - is total number of pax

		SEND("*R")XMIT

		//*** Interface record required ? ***
		DIALOG ("MCO_IT4.DLG", RET_CODE, $StrButton)

		IF $StrButton = "Yes" THEN
			interface_record = "I"
		ELSE
			interface_record = ""
		ENDIF

		//*** More than one MCO ? ***
		SEND("*MCO")XMIT	
		SCREEN_SEARCH(1,1,"*MISCELLANEOUS CHARGE ORDER*",row,col)

		IF row = 1 THEN
			//*** Only 1 MCO exists ***
			//************************************************************************
			//****************** retrieve date from MCO template *********************
			//************************************************************************
			mco_record = 1
			GOSUB(retrieve_mco_template_data)
		ELSE
			//*** Multiple MCO's exist - User Select ***
			:mco_select
			DIALOG ("MCO_IT5.DLG", RET_CODE, mco_record)
			SEND("*MCO",mco_record)XMIT
			SCREEN_SEARCH(1,1,"MCO DATA DOES NOT EXIST FOR THE MCO NUMBER SELECTED",row,col)

			IF row <> 0 THEN
				ALERT("MCO data cannot be retrieved for the selected MCO number.  Please try again.")
				GOTO mco_select
			ENDIF

			//************************************************************************
			//****************** retrieve date from MCO template *********************
			//************************************************************************
			GOSUB(retrieve_mco_template_data)
		ENDIF

		//*** Domestic or International
		SEND("IR")XMIT
		DIALOG ("MCO_IT6.DLG", RET_CODE, dom_or_Int)

		IF dom_or_Int = "Domestic" THEN
			//***Generate codes for EZM entry
			dom_or_Int = "D"
		ELSE
			dom_or_Int = "I"	
		ENDIF		


		//***************************************************
		//*** If fare_per_pax = 'N' and more than one pax ***
		//***************************************************
		IF fare_per_pax = "N" and count > 1 THEN
			OPEN ("C:\NAMELIST.TXT",READ_MODE,file_id2,RET_CODE)

			//If more than one pax in PNR - Obtain ALL Name details from C:\Namelist.txt 
			name_list = "Pax Name(s) - " 
			temp_count = 0

			REPEAT
				READ(file_id2,name_details,RET_CODE)

				IF name_details <> "" THEN
					temp_count = temp_count + 1
					IF temp_count > 1 THEN
						name_list = name_list + ", "
					ENDIF

					//*** Extract name details without PTC etc ***
					INSTR(name_details,"=",1,pos1)
					INSTR(name_details,"*",1,pos2)
					SUBSTR(name_details,name_details,pos1+1,pos2 - (pos1+1))
					name_list = name_list + name_details
				ENDIF
			UNTIL RET_CODE <> 1

			CLOSE(file_id2,RET_CODE)
		ENDIF



		//***************************************************
		//*** If fare_per_pax = 'Y' and more than one pax ***
		//***************************************************
		IF fare_per_pax = "Y" and count > 1 THEN
			//Obtain ALL PTC and Name details (1.1 etc) from C:\Namelist.txt 
			OPEN ("C:\NAMELIST.TXT",READ_MODE,file_id2,RET_CODE)

			REPEAT
				READ (file_id2,name_details,RET_CODE)

				IF name_details <> "" THEN
					name_count = name_count + 1
			
					CASE name_count
						1: pax_1_name = name_details 
		   		BREAK
						2: pax_2_name = name_details
					BREAK
						3: pax_3_name = name_details 
	 		  		BREAK
						4: pax_4_name = name_details
					BREAK
						5: pax_5_name = name_details 
		  	 		BREAK
						6: pax_6_name = name_details
					BREAK
						7: pax_7_name = name_details
	  		 		BREAK
						8: pax_8_name = name_details 
					BREAK
						9: pax_9_name = name_details 
	   			BREAK
					ENDCASE
				ENDIF	 
			UNTIL RET_CODE <> 1
	
			CLOSE(file_id2,RET_CODE)
			SEND("*N")XMIT
			DIALOG ("MCO_IT2.DLG", RET_CODE, all_pax_check_box,pax_1,pax_1_name,pax_2,pax_2_name,pax_3,pax_3_name,pax_4,pax_4_name,pax_5,pax_5_name,pax_6,pax_6_name,pax_7,pax_7_name,pax_8,pax_8_name,pax_9,pax_9_name)
		
			IF all_pax_check_box = 1 THEN //*** ALL pax selected ***
				OPEN ("C:\NAMELIST.TXT",READ_MODE,file_id2,RET_CODE)

				//If more than one pax in PNR - Obtain ALL Name details from C:\Namelist.txt 
				name_list = "Pax Name(s) - " 
				temp_count = 0

				REPEAT
					READ(file_id2,name_details,RET_CODE)

					IF name_details <> "" THEN
						temp_count = temp_count + 1
						IF temp_count > 1 THEN
							name_list = name_list + ", "
						ENDIF

						//*** Extract name details without PTC etc ***
						INSTR(name_details,"=",1,pos1)
						INSTR(name_details,"*",1,pos2)
						SUBSTR(name_details,name_details,pos1+1,pos2 - (pos1+1))
						name_list = name_list + name_details
					ENDIF
				UNTIL RET_CODE <> 1	

				CLOSE(file_id2,RET_CODE)			
			ELSE
				//****************************************
				//*** User has selected individual pax ***
				//****************************************
				specified_pax_switch = 1
				name_list = "Pax Name(s) - " 

				IF pax_1 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_1_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_1_name,"=",1,pos1)
					INSTR(pax_1_name,"*",1,pos2)
					SUBSTR(pax_1_name,pax_1_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF
				
				IF pax_2 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_2_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_2_name,"=",1,pos1)
					INSTR(pax_2_name,"*",1,pos2)
					SUBSTR(pax_2_name,pax_2_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_2_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_3 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_3_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_3_name,"=",1,pos1)
					INSTR(pax_3_name,"*",1,pos2)
					SUBSTR(pax_3_name,pax_3_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_3_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_4 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_4_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_4_name,"=",1,pos1)
					INSTR(pax_4_name,"*",1,pos2)
					SUBSTR(pax_4_name,pax_4_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_5 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_5_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_5_name,"=",1,pos1)
					INSTR(pax_5_name,"*",1,pos2)
					SUBSTR(pax_5_name,pax_5_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_6 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_6_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_6_name,"=",1,pos1)
					INSTR(pax_6_name,"*",1,pos2)
					SUBSTR(pax_6_name,pax_6_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_7 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_7_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_7_name,"=",1,pos1)
					INSTR(pax_7_name,"*",1,pos2)
					SUBSTR(pax_7_name,pax_7_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_8 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_8_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_8_name,"=",1,pos1)
					INSTR(pax_8_name,"*",1,pos2)
					SUBSTR(pax_8_name,pax_8_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_8_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF

				IF pax_9 = 1 THEN
					//*** Extract name id ***
					SUBSTR(name_id,pax_9_name,1,3)
					IF name_select_switch = 1 THEN
						name_id_list = name_id_list + "/"
					ENDIF

					name_id_list = name_id_list + name_id

					//*** Extract name ***
					INSTR(pax_9_name,"=",1,pos1)
					INSTR(pax_9_name,"*",1,pos2)
					SUBSTR(pax_9_name,pax_9_name,pos1+1,pos2 - (pos1+1))

					IF name_select_switch = 1 THEN
						name_list = name_list + ", "
					ENDIF

					name_list = name_list + pax_1_name
					name_select_switch = 1 //*** tells the script than more than one name selected
				ENDIF
			ENDIF
		ENDIF

	
		IF refund_voucher = 1 THEN
			DIALOG ("MCO_IT7.DLG", RET_CODE, orig_tkt_number,orig_place_of_issue,orig_date_of_issue,orig_IATA,orig_fop)
			//EZM#$*EET12590106180573*A/OILON12SEP079999999/O$CA#M4/STI
			SEND("EZM",interface_record,"#$*EET",orig_tkt_number,"*A/OI",orig_place_of_issue,orig_date_of_issue,orig_IATA,"/O$",orig_fop,"#M",mco_record,"/ST",dom_or_Int) 
		ELSE
			SEND("EZM",interface_record,"#M",mco_record,"/ST",dom_or_Int) 
		ENDIF

		IF specified_pax_switch = 0 THEN
			XMIT
		ELSE
			//*** Add name select to EZM entry ***
			SEND("#N",name_id_list)XMIT
		ENDIF

		SEND("*" + locator)XMIT
		
		//IF mco airline name is 2 characters then it will be used in OSI entry.  If not script will pull from itin.
		STRLEN(airline_name,mco_airline_name_length)

		IF mco_airline_name_length > 2 THEN
			SEND("*IA")XMIT
			READ_SCREEN(1,4,2,carrier)
		ELSE
			carrier = airline_name
		ENDIF	


		//*******************************************************************
		//*************** Obtain data from Document History *****************
		//*******************************************************************
		SEND("*DH")XMIT
		SCREEN_SEARCH (1,1,"NO DOC HISTORY DATA FOUND",row,col)	// Document History Exist

		IF row <> 0 THEN
			ABORT("Script Aborting - Unable to retrieve Document History.")
		ENDIF


		//***Does more then 1 Document History in PNR exist***
		SCREEN_SEARCH (1,1,"**DOCUMENT COMMANDS**",row,col)

		IF row <> 0 THEN
			//*** Only one ticket/Doc History *** 
			GOSUB (document_history)
		ELSE
			//*** Multiple tickets/Document History
			:specify_dh
			DIALOG ("MCO_IT1.DLG", RET_CODE, doc_history_item,$StrButton)
				
			IF $StrButton = "View Document History (*DH)" THEN 
				PAUSE
				GOTO specify_dh
			ENDIF

			SEND ("*DH",doc_history_item) XMIT
			SCREEN_SEARCH (1,1,"NO DOC ",row,col)

			IF row <> 0 THEN 
				ALERT("Unable to retrieve document history item number "+ doc_history_item + ".")
				GOTO specify_dh
			ENDIF
		
			GOSUB (document_history)		
		ENDIF

		SEND(">3OSI",carrier,"MPD",mco_number)XMIT
		SEND("ER")XMIT

		//*************************************************
		//*** Write data to text file and print 3 times ***
		//*************************************************
		
		header = "*** AUDIT COUPON ***"
		GOSUB(write_to_text_file)
		header = "*** AGENT COUPON ***"
		GOSUB(write_to_text_file)
		header = "*** EXCHANGE COUPON ***"
		GOSUB(write_to_text_file)

		SEND("*R")XMIT
		ALERT("MCO Data has been printed successfully")

		END
ENDS
